/**
 * Calendar
 * @version V20090104
 * @author  KimSoft (jinqinghua [at] gmail.com)
 * @see http://code.google.com/p/kimsoft-jscalendar/
 * @modified by ForeUI (www.foreui.com)
 */
var Calendar = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Calendar.prototype = {
	_resource: {
		"year"   : ["\u5e74", "", "", "\u5e74","\u5e74"],
		"months" : [
					["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"],
					["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
					["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"],
					["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"],
					["\u4e00\u6708","\u4e8c\u6708","\u4e09\u6708","\u56db\u6708","\u4e94\u6708","\u516d\u6708","\u4e03\u6708","\u516b\u6708","\u4e5d\u6708","\u5341\u6708","\u5341\u4e00\u6708","\u5341\u4e8c\u6708"]				
					],
		"months_mini" : [
					["1","2","3","4","5","6","7","8","9","10","11","12"],
					["1","2","3","4","5","6","7","8","9","10","11","12"],
					["1","2","3","4","5","6","7","8","9","10","11","12"],
					["1","2","3","4","5","6","7","8","9","10","11","12"],
					["1","2","3","4","5","6","7","8","9","10","11","12"]			
					],
		"weeks"  : [["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
					["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
					["Sun","Mon","Tur","Wed","Thu","Fri","Sat"],
					["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
					["\u65e5","\u6708","\u706b","\u6c34","\u6728","\u91d1","\u571f"]
				],
		"weeks_mini"  : [["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
					["S","M","T","W","T","F","S"],
					["S","M","T","W","T","F","S"],
					["\u65e5","\u4e00","\u4e8c","\u4e09","\u56db","\u4e94","\u516d"],
					["\u65e5","\u6708","\u706b","\u6c34","\u6728","\u91d1","\u571f"]
				],
		"date2StringPattern" : ["yyyy-MM-dd", "yyyy-MM-dd", "yyyy-MM-dd", "yyyy-MM-dd", "yyyy-MM-dd"],
		"string2DatePattern" : ["ymd","ymd", "ymd", "ymd", "ymd"]
	},
	init: function() {
		var params = this._params;
		params.date2StringPattern = this._resource["date2StringPattern"][params.language].replace(/\-/g, params.patternDelimiter);
		params.string2DatePattern = this._resource["string2DatePattern"][params.language];
		
		var dateParts = params.selectedDate.split(params.patternDelimiter);
		params.date = new Date(dateParts[0], dateParts[1] - 1, dateParts[2]);
		params.year = params.date.getFullYear();
		params.month = params.date.getMonth();
		
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
			
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		var mini_mode = width < 200 || height < 200;
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		// content
		var _cs = [];
		_cs[_cs.length] = '<table cellpadding="1" cellspacing="1" style="background-color:transparent;">';
		_cs[_cs.length] = ' <tr height="20">';
		_cs[_cs.length] = '  <th colspan="7">';
		_cs[_cs.length] = '   <form method="post">';
		_cs[_cs.length] = '    <table cellspacing="0" cellpadding="0">';
		_cs[_cs.length] = '     <tr>';
		_cs[_cs.length] = '      <th><input onfocus="blur()" class="goPrevMonthButton" type="button" value="&lt;" \/><\/th>';
		_cs[_cs.length] = '      <th colspan="5"><nobr><select class="yearSelect"><\/select> <select class="monthSelect"><\/select><nobr><\/th>';
		_cs[_cs.length] = '      <th ><input onfocus="blur()" class="goNextMonthButton" type="button" value="&gt;" \/><\/th>';
		_cs[_cs.length] = '     <\/tr>';
		_cs[_cs.length] = '    <\/table>';
		_cs[_cs.length] = '   <\/form>';
		_cs[_cs.length] = '  <\/th>';
		_cs[_cs.length] = ' <\/tr>';
		_cs[_cs.length] = ' <tr>';
		for(var i = 0; i < 7; i++) {
			if (i == 0) {
				_cs[_cs.length] = '<th class="header">';
			} else {
				_cs[_cs.length] = '<th class="header" width="14.3%">';
			}
			if (mini_mode == true) {
				_cs[_cs.length] = this._resource["weeks_mini"][params.language][i];
			} else {
				_cs[_cs.length] = this._resource["weeks"][params.language][i];
			}
			_cs[_cs.length] = '<\/th>';	
		}
		_cs[_cs.length] = '<\/tr>';
		for(var i = 0; i < 6; i++){
			_cs[_cs.length] = '<tr align="center">';
			for(var j = 0; j < 7; j++) {
				switch (j) {
					case 0: _cs[_cs.length] = '<td class="sun button">&nbsp;<\/td>'; break;
					case 6: _cs[_cs.length] = '<td class="sat button">&nbsp;<\/td>'; break;
					default: _cs[_cs.length] = '<td class="normal button">&nbsp;<\/td>'; break;
				}
			}
			_cs[_cs.length] = '<\/tr>';
		}
		_cs[_cs.length] = '<\/table>';
		_fg.html(_cs.join(""));
		
		// styling
		var ctrlRowHeight = Math.min(20, height * 0.15);
		var headerHeight = Math.min(20, height * 0.25 - ctrlRowHeight);
		var tables = _fg.find("table");
		var fontName = params.f_n_0;
		var fontSize = mini_mode ? params.f_s_0 * 0.75 : params.f_s_0;
		tables.css({
			"margin" : "0px",
			"width" : "100%",
			"height" : "100%",
			"background" : "transparent",
			"text-align" : "center",
			"border" : "0px",
			"font-family" : fontName,
			"font-size" : fontSize + "px"
		});
		_fg.find("form").css("margin", "0px");
		_fg.find(".goPrevMonthButton, .goNextMonthButton").css({
			"border-width" : params.bdw_0 + "px",
			"border-color" : params.borderColor,
			"background-color" : params.buttonColor,
			"width" : mini_mode ? "12px" : "20px",
			"height" : ctrlRowHeight + "px",
			"padding" : "0px",
			"font-family" : fontName,
			"font-size" : fontSize + "px",
			"color" : params.normalTextColor
		});
		_fg.find("select").css({
			"background-color" : params.buttonColor,
			"border-width" : "1px",
			"border-style" : "solid",
			"border-color" : params.borderColor,
			"font-family" : fontName,
			"font-size" : fontSize + "px",
			"height" : ctrlRowHeight + "px",
			"color" : params.normalTextColor
		});
		_fg.find(".header").css({
			"height" : headerHeight + "px",
			"font-weight" : "normal",
			"background-color" : params.headerBgColor,
			"color" : params.headerTxtColor,
			"text-align" : "center"
		});
		_fg.find(".button").css({
			"cursor" : "pointer",
			"background-color" : params.buttonColor,
			"font-family" : fontName,
			"font-size" : fontSize + "px"
		});
		
		// update data
		this._bindYear(obj);
		this._bindMonth(obj);
		this._changeSelect(obj);
		this._bindData(obj);
		
		// bind behavior
		this.setupBehavior(obj);
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior: function(obj) {
		if (obj.find("form").size() > 0) {
			var calendar = this;
			obj.find(".goPrevMonthButton").get(0).onclick = function () { calendar._goPrevMonth(obj); }
			obj.find(".goNextMonthButton").get(0).onclick = function () { calendar._goNextMonth(obj); }
			obj.find(".yearSelect").get(0).onchange = function () { calendar._update(obj); }
			obj.find(".monthSelect").get(0).onchange = function () { calendar._update(obj); }
		}
	},
	_bindYear: function(obj) {
		var params = this._params;
		var ys = obj.find(".yearSelect").get(0);
		ys.length = 0;
		for (var i = params.beginYear; i <= params.endYear; i++){
			ys.options[ys.length] = new Option(i + this._resource["year"][params.language], i);
		}
	},
	_bindMonth: function(obj) {
		var width = obj.width();
		var height = obj.height();
		var mini_mode = width < 200 || height < 200;
		var params = this._params;
		var ms = obj.find(".monthSelect").get(0);
		ms.length = 0;
		for (var i = 0; i < 12; i++){
			if (mini_mode) {
				ms.options[ms.length] = new Option(this._resource["months_mini"][params.language][i], i);
			} else {
				ms.options[ms.length] = new Option(this._resource["months"][params.language][i], i);
			}
		}
	},
	_changeSelect: function(obj) {
		var params = this._params;
		var ys = obj.find(".yearSelect").get(0);
		var ms = obj.find(".monthSelect").get(0);
		for (var i= 0; i < ys.length; i++){
			if (ys.options[i].value == params.date.getFullYear()){
				ys[i].selected = true;
				break;
			}
		}
		for (var i= 0; i < ms.length; i++){
			if (ms.options[i].value == params.date.getMonth()){
				ms[i].selected = true;
				break;
			}
		}
	},
	_bindData: function (obj) {
		var params = this._params;
		var calendar = this;
		var dateArray = this._getMonthViewDateArray(params.date.getFullYear(), params.date.getMonth());
		obj.find(".button").each(function(i) {
			var today = params.date;
			this.onclick = null;
			this.onmouseover = null;
			this.onmouseout = null;
			this.innerHTML = dateArray[i] || "&nbsp;";
			if (i <= dateArray.length - 1 && dateArray[i]){
				if ((i % 7) == 0) {
					this.style.color = params.sundayTextColor;
				} else if ((i % 7) == 6) {
					this.style.color = params.saturdayTextColor;
				} else {
					this.style.color = params.normalTextColor;
				}
				this.onclick = function () {
					var button = $(this);
					if (button.attr("sel") != "true") {
						// set current date
						params.date = new Date(params.date.getFullYear(), params.date.getMonth(), this.innerHTML);
						params.year = today.getFullYear();
						params.month = today.getMonth();
						
						// reset all td background color
						calendar._resetAllCellBgColors(obj);
	
						// select clicked button
						$(this).attr("sel", "true").css("background-color", params.buttonSelectedColor); 
						
						// update references
						updateElementAndReferences(calendar);
						
						// trigger date changed event
						$("#" + calendar._id).trigger("Calendar_Date_Changed");
					}
				}
				this.onmouseover = function () { $(this).css("background-color", params.buttonHoverColor); }
				this.onmouseout = function () {
					var button = $(this);
					button.css("background-color",  button.attr("sel") == "true" ? params.buttonSelectedColor : params.buttonColor);
				}
				
				$(this).attr("sel", "false");
				if (today.getFullYear() == params.date.getFullYear()) {
					if (today.getMonth() == params.date.getMonth()) {
						if (today.getDate() == dateArray[i]) {
							$(this).attr("sel", "true").css("background-color", params.buttonSelectedColor);
						}
					}
				}
			}
		});
	},
	_getMonthViewDateArray: function (y, m) {
		var dateArray = new Array(42);
		var dayOfFirstDate = new Date(y, m, 1).getDay();
		var dateCountOfMonth = new Date(y, m + 1, 0).getDate();
		for (var i = 0; i < dateCountOfMonth; i++) {
			dateArray[i + dayOfFirstDate] = i + 1;
		}
		return dateArray;
	},
	_resetAllCellBgColors: function(obj) {
		var params = this._params;
		obj.find(".button").each(function(k) {
			$(this).attr("sel", "false")
				.css("background-color", params.buttonColor);
		});
	},
	_update: function(obj) {
		var params = this._params;
		var ys = obj.find(".yearSelect").get(0);
		params.year  = ys.options[ys.selectedIndex].value;
		var ms = obj.find(".monthSelect").get(0);
		params.month = ms.options[ms.selectedIndex].value;
		params.date = new Date(params.year, params.month, 1);
		this._resetAllCellBgColors(obj);
		this._changeSelect(obj);
		this._bindData(obj);
		updateElementAndReferences(this);
	},
	_goPrevMonth: function(obj) {
		var params = this._params;
		if (params.year == params.beginYear && params.month == 0) { return; }
		params.month--;
		if (params.month == -1) {
			params.year--;
			params.month = 11;
		}
		params.date = new Date(params.year, params.month, 1);
		this._resetAllCellBgColors(obj);
		this._changeSelect(obj);
		this._bindData(obj);
		updateElementAndReferences(this);
	},
	_goNextMonth: function(obj) {
		var params = this._params;
		if (params.year == params.endYear && params.month == 11) { return; }
		params.month++;
		if (params.month == 12) {
			params.year++;
			params.month = 0;
		}
		params.date = new Date(params.year, params.month, 1);
		this._resetAllCellBgColors(obj);
		this._changeSelect(obj);
		this._bindData(obj);
		updateElementAndReferences(this);
	},
	_str2Date: function(str, delimiter, pattern) {
		delimiter = delimiter || "-";
		pattern = pattern || "ymd";
		var a = str.split(delimiter);
		if (a.length != 3) throw new Error("Incorrect Format");
		var y = parseInt(a[pattern.indexOf("y")], 10);
		if(isNaN(y)) throw new Error("Year Not Found");
		if(y.toString().length <= 2) y += 2000;
		var m = parseInt(a[pattern.indexOf("m")], 10) - 1;
		if(isNaN(m)) throw new Error("Month Not Found");
		var d = parseInt(a[pattern.indexOf("d")], 10);
		if(isNaN(d)) throw new Error("Day Not Found");
		return new Date(y, m, d);
	},
	getDateString: function() {
		var params = this._params;
		var style = params.date2StringPattern;
		var date = params.date;
		var o = {
			"M+" : date.getMonth() + 1, //month
			"d+" : date.getDate(),      //day
			"h+" : date.getHours(),     //hour
			"m+" : date.getMinutes(),   //minute
			"s+" : date.getSeconds(),   //second
			"w+" : "\u65e5\u4e00\u4e8c\u4e09\u56db\u4e94\u516d".charAt(date.getDay()),   //week
			"q+" : Math.floor((date.getMonth() + 3) / 3),  //quarter
			"S"  : date.getMilliseconds() //millisecond
		}
		if (/(y+)/.test(style)) {
			style = style.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
		}
		for(var k in o){
			if (new RegExp("("+ k +")").test(style)){
				style = style.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
			}
		}
		return style;
	},
	getYear: function() {
		return this._params.date.getFullYear();
	},
	getMonth: function() {
		return this._params.date.getMonth() + 1;
	},
	getDay: function() {
		return this._params.date.getDate();
	},
	setDateString: function(targets, value) {
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem) {
				var params = elem._params;
				var newDate = new Date();
				try {
					newDate = elem._str2Date(value, params.patternDelimiter, params.string2DatePattern);
				} catch (err) {}
				if (params.date != newDate) {
					params.date = newDate;
					params.year = newDate.getFullYear();
					params.month = newDate.getMonth();
					updateElementAndReferences(elem);
					$("#" + elem._id).trigger("Calendar_Date_Changed");
				}
			}
		}
	},
	fireDateChangedEvent: function(targets) {
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem) {
				$("#" + elem._id).trigger("Calendar_Date_Changed");
			}
		}
	}
};