var ComboBox = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

ComboBox.prototype = {
	init : function() {
		var params = this._params;
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg vcenter_outter\"><div class=\"vcenter_middle\"><div class=\"vcenter_inner\">" + params.items[params.sel_index] + "</div></div><div class=\"btn\"></div></div>")
			.appendTo(this._obj);
			
		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		var showDecoration = params.decoration;
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// text
		var margin = params.margin;
		_fg.width(width).height(height).css({
			"padding-left" : margin,
			"padding-right" : margin,
			"cursor": (state == 64 || state == 96) ? "default" : "pointer"
		});
		applyFontParameters(state, "", _fg.find(".vcenter_middle"), params);
		if (_fg.width() == width) {
			_fg.width(width - margin * 2)
				.find(".vcenter_middle").css("left", margin + "px");
		}
		_fg.find(".vcenter_inner").html(params.items[params.sel_index]);
		
		// button
		var buttonMargin = params["btnm_" + state];
		var buttonRc = {};
		buttonRc.height = height;
		buttonRc.width = height * params["whr_" + state];
		buttonRc.x = width - buttonRc.width + buttonMargin;
		buttonRc.y = buttonMargin;
		buttonRc.width -= buttonMargin * 2;
		buttonRc.height -= buttonMargin * 2;
		if (params["bdt_" + state] == "swing") {
			var borderWidth = params["bdw_" + state];
			var halfWidth = borderWidth / 2;
			buttonRc.x += halfWidth;
			buttonRc.y += halfWidth;
			buttonRc.width -= borderWidth;
			buttonRc.height -= borderWidth;
		}
		
		var btn = _fg.children(".btn").css("position", "absolute");
		btn.css("visibility", showDecoration ? "inherit" : "hidden");
		var btnbdt = params["btnbd_t_" + state];
		var btnbdl = params["btnbd_l_" + state];
		var btnbdb = params["btnbd_b_" + state];
		var btnbdr = params["btnbd_r_" + state];
		btn.css({
			"left" : buttonRc.x + "px",
			"top" : buttonRc.y + "px",
			"width" : buttonRc.width + "px",
			"height" : buttonRc.height + "px",
			"border-width" : "0px",
			"cursor" : (state == 64 || state == 96) ? "default" : "pointer"
		});
		generateBackgroundAndBorders(state, "btn", btn, btn, params);
		
		var btni = params["btni_" + state];
		if (btni) {
			var btnIcon = new Image();
			btnIcon.onload = function() {
				var x = (buttonRc.width - btnbdl - btnbdr - this.width) / 2;
				var y = (buttonRc.height - btnbdt - btnbdb - this.height) / 2;
				btn.children(".icon").remove();
				btn.append($("<img class=\"icon\" style=\"position:absolute; left:" + x + "px; top:" + y + "px;\" src=\"" + btnIcon.src + "\" />"));
			};
			btnIcon.src = "images/" + btni;
		}
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var params = this._params;
		var me = this;
		obj.mouseenter(function() {
			setState(me, 16);
		}).mouseleave(function() {
			setState(me, 0);
		}).mousedown(function() {
			if ((params.state & 64) == 0) {
				me._popup(obj);
			}
		});
	},
	_popup : function(obj) {
		var me = this;
		var params = this._params;
		var state = params.state;
		var width = obj.width();
		var height = obj.height();
		var objId = obj.attr("id");

		var ownerPage = obj.parents(".page");
		ownerPage.find("#" + objId + "__Popup").remove();
		var popupPaddingX = params["pppx_" + state];
		var popupPaddingY = params["pppy_" + state];
		var popup = $("<div id=\"" + objId + "__Popup\"></div>").css({
			"position" : "absolute",
			"z-index" : "10000",
			"left" : "0px",
			"top" : height + "px",
			"padding-top" : popupPaddingY + "px"
		}).appendTo(ownerPage);
		applyFontParameters(state, "pp", popup, params);
		
		var items = params.items;
		var itemFgCss = {
			"position" : "absolute",
			"left" : popupPaddingX + "px",
			"border" : "0px",
			"overflow" : "hidden",
			"cursor" : "default"
		};
		var popupWidth = 0, popupHeight = popupPaddingY;
		var resetItems = function() {
			var items = popup.find(".item");
			items.css({
					"border-width" : "0px",
					"background-color" : "transparent" 
				});
			items.find(".linearBg").remove();
			items.find(".swingBd").remove();
			applyFontParameters(state, "pp", items.find(".itemFg"), params);
		};
		var hoverHandler = function(event) {
			var target = $(event.target);
			var item = target.hasClass("item") ? target : target.parents(".item");
			if (params.hlIndex != item.index()) {
				params.hlIndex = item.index();
				resetItems();
				item.css("border-width", "0px").width("100%").height(itemHeight);
				generateBackgroundAndBorders(state, "ph", item, item, params);
				applyFontParameters(state, "ph", item.find(".itemFg"), params);
			}
		};
		var leaveHandler = function() {
			params.hlIndex = -1;
			resetItems();
		};
		var clickHandler = function(event) {
			var target = $(event.target);
			var item = target.hasClass("item") ? target : target.parents(".item");
			var bkSel = params.sel_index;
			params.sel_index = item.index() - item.siblings(".swingBd").size();
			popup.remove();
			if (bkSel != params.sel_index) {
				updateElementAndReferences(me);
				$("#" + me._id).trigger("Selection_Changed");
			}
		}
		for (var i = 0; i < items.length; i ++) {
			var itemSize = getTextSize(items[i], params.ppf_n_0, params.ppf_s_0, params.ppf_b_0);
			var itemHeight = itemSize.height + popupPaddingY;
			var item = $("<div class=\"item\"></div>").width("100%").height(itemHeight).appendTo(popup);
			var itemFg = $("<div class=\"itemFg\">" + items[i] + "</div>").appendTo(item);
			itemFg.css(itemFgCss).height(itemSize.height).css("top", popupPaddingY * 1.5 + i * itemHeight);
			item.mouseover(hoverHandler).mouseleave(leaveHandler).click(clickHandler);
			popupWidth = Math.max(popupWidth, itemSize.width);
			popupHeight += itemHeight;
		}
		popupWidth = Math.max(popupWidth + 2 * popupPaddingX, width);
		popup.width(popupWidth).height(popupHeight)
			.position({
				my : "left top",
				at : "left bottom",
				of : obj,
				collision : "fit"
			});
		generateBackgroundAndBorders(state, "pp", popup, popup, params);
			
		var handler = function(event) {
			var popupObj = popup.get(0);
			if (event.target != popupObj && !$.contains(obj.get(0), event.target) && !$.contains(popupObj, event.target)) {
				popup.remove();
				$(document).unbind("mousedown", handler);
			}
		};
		$(document).bind("mousedown", handler);
	},
	getSelectedIndex : function() {
		return this._params.sel_index + 1;
	},
	setSelectedIndex : function(index) {
		var params = this._params;
		if (index > 0 && index <= params.items.length && params.sel_index != index - 1) {
			params.sel_index = index - 1;
			updateElementAndReferences(this);
			$("#" + this._id).trigger("Selection_Changed");
		}
	},
	getSelectedText : function() {
		var params = this._params;
		return textFromView(params.items[params.sel_index]).replace(/&lt;/gi, "<").replace(/&gt;/gi, ">");
	},
	setCurrentValue : function(value) {
		var params = this._params;
		var oldVal = params.items[params.sel_index];
		var newVal = htmlToView(value);
		if (oldVal != newVal) {
			var pos = $.inArray(newVal, params.items);
			if (pos != -1) {
				params.sel_index = pos;
			} else {
				params.sel_index = params.items.length;
				params.items.push(newVal);
			}
			updateElementAndReferences(this);
			$("#" + this._id).trigger("Selection_Changed");
		}
	},
	addItem : function(targets, index, text) {
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem && elem._params && elem._params.items) {
				if (index == 0) {
					elem._params.items.splice(elem._params.items.length, 0, text);
				} else {
					elem._params.items.splice(index - 1, 0, text);
				}
			}
		}
	},
	deleteItem : function(targets, index) {
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem && elem._params && elem._params.items) {
				if (index == 0) {
					elem._params.items = [];
				} else if (index > 0 && index <= elem._params.items.length) {
					elem._params.items.splice(index - 1, 1);
				}
			}
		}
	}
};