var IFrame = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

IFrame.prototype = {
	init : function() {
		var params = this._params;
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
		
		var iframe = $("<iframe class=\"iframe\" style=\"position:absolute;width:100%;height:100%;\"></iframe>").attr({
			"frameborder" : "0",
			"scrolling" : params.scrolling,
			"allowTransparency" : "true"
		}).appendTo(this._fg);	
		if (params.url) {
			iframe.attr("src", params.url);
		}

		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		var borderDelta = params.bdw_0 + params.bdsw_amp_0;
		
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		var iframe = _fg.children(".iframe").css({
			"left" : borderDelta + "px",
			"top" : borderDelta + "px",
			"width" : (width - borderDelta * 2) + "px",
			"height" : (height - borderDelta * 2) + "px"
		});
		if (iframe.attr("src") != params.url) {
			iframe.attr("src", params.url);
		}
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setCurrentValue : function(value) {
		var params = this._params;
		if (params.url != value) {
			params.url = value;
			updateElementAndReferences(this);
		}
	}	
};