var ImageBox = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

ImageBox.prototype = {
	init: function() {
		var params = this._params;
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"><img style=\"position:absolute;width:100%;height:100%;border:0px;display:none;\" /></div>")
			.appendTo(this._obj);
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var width = obj.width();
		var height = obj.height();
		// must re-obtain the fg, bd and bg, as they may come from reference
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var _img = _fg.children("img");
		_fg.find("canvas").remove();
		
		if (params.shadow) {
			obj.css("overflow", "visible");
			_fg.css("overflow", "visible");
		}
		
		// image content
		if (params.src) {
			_img.attr("src", "");
			_img.attr("src", "images/dock/" + params.src).css("display", "block");
			applyDropShadow(obj, _img, params);
		} else if (params.url) {
			_img.attr("src", "");
			_img.attr("src", params.url).css("display", "block");
			applyDropShadow(obj, _img, params);
		}else {
			// background filling
			_img.css("display", "none");
			_bd.css("border-width", "0px").width(width).height(height);
			generateBackgroundAndBorders(0, "", _bg, _bd, params);
			// create canvas
			var canvas = createCanvas(width, height, params);
			canvas.style.position = "absolute";
			_fg.append(canvas);
			// draw on canvas
			var ctx = getCanvasContext(canvas, params);
			ctx.strokeStyle = params["bdc_" + params.state];
			ctx.beginPath();
			ctx.rect(0, 0, width, height);
			var bdw = params.bdw_0;
			var start = { x : bdw, y : height * 0.7 };
			var end = { x : width * 0.25, y : height * 0.2};
			drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, false);
			start = end;
			end = {x : width * 0.5, y : height * 0.8};
			drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, true);
			start = end;
			end = {x : width * 0.7, y : height * 0.5};
			drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, true);
			start = end;
			end = {x : width - bdw, y : height - bdw};
			drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, true);
			fillAndStrokeOnCanvas(ctx, width, height, params, true);
			drawEllipse(ctx, width * 0.6 - bdw, height * 0.1 + bdw, width * 0.25, height * 0.25, params, true);
		}
	},
	setImageSource: function(src) {
		var params = this._params;
		params.src = src;
		updateElementAndReferences(this);
	},
	setImageUrl: function(url) {
		var params = this._params;
		params.url = url;
		params.src = undefined;
		updateElementAndReferences(this);
	}
};