var List = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

List.prototype = {
	init : function() {
		var params = this._params;
		var content = this._obj.children();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
		
		var rowHeight = params.rowh;
		var gap = params.gap;
		var icons = params.icons;
		var margin = params.txtm;
		var list = $("<table style=\"position:absolute;\" cellspacing=\"0\" cellpadding=\"0\"></table>").appendTo(this._fg);
		content.children("li").each(function(index) {
			var label = createLabelObject(icons[index], 0, gap, $(this).html());
			var listCell = $("<td valign=\"middle\" class=\"listCell\"></td>").append(label).height(rowHeight);
			var listRow = $("<tr class=\"listRow\"></tr>").append(listCell).appendTo(list);
			listRow.children().css({
				"padding-left" : margin + "px"
			});
		});
		
		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var me = this;
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();

		// list size
		var borderWidth = params["bdw_" + state];
		var listTable = _fg.children("table");
		listTable.css({
			left : borderWidth + "px",
			top : borderWidth + "px",
			width : (width - borderWidth * 2) + "px",
			height : (height - borderWidth * 2) + "px"
		});
		
		var paintBorder = params["pbdr_" + state];
		var paintHorLines = params["horl_" + state];

		// background and border
		_bd.css("border-width", "0px").width(obj.width()).height(obj.height());
		if (!paintBorder) {
			params["bdt_" + state] = "none";
		}
		var mainBg = params["bg"];
		var mainBgState = params["bg_" + state];
		params["bg"] = "transparent";
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		params["bg"] = mainBg;

		// add padding rows
		var rowCount = params.rows;
		var rowHeight = params.rowh;
		var actualRowCount = Math.ceil(height / rowHeight);
		var paddingRowCount = Math.max(0, actualRowCount - rowCount);
		var lastPaddingRowHeight = rowHeight - height + (paddingRowCount - 1) * rowHeight - borderWidth;
		var listBody = listTable.children();
		listBody.children(".paddingRow").remove();
		for (var i = 0; i < paddingRowCount; i ++) {
			listBody.append($("<tr class=\"listRow paddingRow\"><td class=\"listCell\"></td></tr>").height(i == paddingRowCount - 1 ? lastPaddingRowHeight : rowHeight));
		}
		
		// prepare rows in bg
		_bg.children("table").remove();
		var bgRows = listTable.clone().appendTo(_bg).find(".listCell").css("padding-left", "0px").width("100%").html("");
		
		// prepare rows in bd
		_bd.children("table").remove();
		var bdRows = listTable.clone().appendTo(_bd).find(".listCell").css("height", rowHeight + "px").width("100%").html("");

		// tweak rows
		var margin = params.txtm;
		var selRow = params.selr;
		var gap = params.gap;
		var icons = params.icons;
		listBody.children(".listRow").each(function(index) {
			var listRow = $(this);
			var fgCell = listRow.children();
			var bgCell = $(bgRows.get(index));
			var bdCell = $(bdRows.get(index));
			var isLastRow = index == actualRowCount - 1;
			var tarId = "row";
			if (index % 2 == 1) {
				tarId = "alt";
			}
			if (index == selRow) {
				tarId = "sel";
			}
			generateBackgroundAndBorders(state, tarId, bgCell, bdCell, params);
			if (!listRow.hasClass("paddingRow")) {
				applyFontParameters(state, tarId, fgCell, params);
				var preferredWidth = getTextSize(fgCell.text(), params["rowf_n_" + state], params["rowf_s_" + state]).width;
				if (icons[index]) {
					preferredWidth += gap + fgCell.find(".icon").width();
				}
				fgCell.css("padding-left", "0px");
				var actualMargin = Math.max(0, Math.min(margin, (width - preferredWidth) / 2));
				fgCell.css("padding-left", actualMargin + "px");
			}
			if (paintHorLines && !isLastRow) {
				bdCell.css({
					"border-bottom-style" : "solid",
					"border-bottom-color" : params[tarId + "bdc_" + state],
					"border-bottom-width" : borderWidth + "px"
				});
			}
		});
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		var listRows = obj.children(".fg").children("table").children().children(".listRow");
		listRows.click(function() {
			if ((me._params.state & 64) == 0) {
				me.setSelectedIndex(listRows.index(this) + 1);
			}
		});
	},
	getSelectedIndex : function() {
		return this._params.selr + 1;
	},
	setSelectedIndex : function(index) {
		var params = this._params;
		if (params.selr != index - 1) {
			params.selr = index - 1;
			updateElementAndReferences(this);
			$("#" + this._id).trigger("Selection_Changed");
		}
	},
	getSelectedText : function() {
		var index = this._params.selr;
		if (index == -1) {
			return "";
		}
		var node = this._fg.children("table").children().children(".listRow").eq(index).children(".listCell").children(".label");
		return textFromView(node.text());
	}
};