var LocalStorage = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this._guid = generateGUID();
	this._storage = [];
	this.init();
};

LocalStorage.prototype = {
	init : function() {
		if (this.isSupported()) {
			var localDirtyKey = this.getLocalDirtyKey();
			var remoteDirtyKey = this.getRemoteDirtyKey();
			$(window).bind("storage", function(e) {
				if (sessionStorage.getItem(localDirtyKey) == "true") {
					sessionStorage.setItem(remoteDirtyKey, "true");
				}
			});
		}
	},
	updateUI : function(obj) {},
	setupBehavior : function(obj) {},
	isSupported : function() {
		if(typeof(Storage) === "undefined") {
			alert("Sorry, seems your web browser doesn't support local storage.");
			return false;
		}
		return true;
	},
	getLocalDirtyKey : function() {
		return "foreui.storage.local.dirty." + this._id;
	},
	getRemoteDirtyKey : function() {
		return "foreui.storage.remote.dirty." + this._guid;
	},
	setDataByKey : function(dataKey, dataVal) {
		if (this.isSupported()) {
			if ($.isPlainObject(dataVal)) {
				dataType = 'O';
			} else if ($.isArray(dataVal)) {
				dataType = 'A';
			} else if (isNumber(dataVal)) {
				dataType = 'N';
			} else {
				dataType = 'S';
			}
			localStorage.setItem("foreui." + this._id + "." + dataKey, "[" + dataType + "]" + $.toJSON(dataVal));
			sessionStorage.setItem(this.getLocalDirtyKey(), "true");
		}
	},
	getDataByKey : function(dataKey) {
		if (this.isSupported()) {
			return this.getData()[dataKey];
		}
		return undefined;
	},
	getData : function() {
		var localDirtyKey = this.getLocalDirtyKey();
		var remoteDirtyKey = this.getRemoteDirtyKey();
		if (sessionStorage.getItem(localDirtyKey) != "false" || sessionStorage.getItem(remoteDirtyKey) != "false") {
			this._storage = [];
			var prefix = "foreui." + this._id + ".";
			for (var key in localStorage) {
			  if (localStorage.hasOwnProperty(key) && key.indexOf(prefix) == 0) {
			  	var data = localStorage.getItem(key);
			  	var dataType = data.substring(1, 2);
			  	var dataValue = $.parseJSON(data.substring(3));
			    this._storage[key.replace(prefix, "")] = dataValue;
			  }
			}
			if (sessionStorage.getItem(localDirtyKey) == "true") {
				sessionStorage.setItem(localDirtyKey, "false");
			}
			if (sessionStorage.getItem(remoteDirtyKey) == "true") {
				sessionStorage.setItem(remoteDirtyKey, "false");
			}
		}
		return this._storage;
	}
};