var MockText = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

MockText.prototype = {
	init : function() {
		var params = this._params;
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
			
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg").empty();
		var width = obj.width();
		var height = obj.height();
		var borderDelta = params.bdw_0 + params.bdsw_amp_0;
		
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		var lineHeight = params.lineHeight;
		var linePadding = params.linePadding;
		var opaque = params.bgo_0 > 0;
		var canvas = createCanvas(width, height, opaque ? undefined : params);
		_fg.empty().append(canvas);
		var ctx = opaque ? canvas.getContext('2d') : getCanvasContext(canvas, params);
		ctx.strokeStyle = params.f_c_0;
		ctx.lineWidth = lineHeight;
		for (var lineOffsetY = 0; lineOffsetY < height; lineOffsetY += lineHeight + linePadding) {
			var lineY = lineOffsetY + lineHeight / 2 + params.bdsw_amp_0;
			var start = { x : 0, y : lineY };
			var end = { x : width, y : lineY };
			ctx.beginPath();
			drawSwingLine(ctx, start, end, params.bdsw_int_0, params.bdsw_amp_0, false, true);
			ctx.closePath();
		}
		
		// shadow
		if (opaque) {
			applyShadow(obj, $(canvas), params.shadow);
		}
	}
};