var MultilevelMenu = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

MultilevelMenu.prototype = {
	init : function() {
		var me = this;
		setTimeout(function() {
			me.setupBehavior(me._obj);
			initReferences(me);
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		// shadow
		var params = this._params;
		obj.children(".elem").each(function(index) {
			applyShadow(obj, $(this), params.shadow);
		});
	},
	setupBehavior : function(obj) {
		var me = this;
		var menuIds = this._params.menuIds;
		var firstMenuObj = getForeUIElementById(me._id + "_")._obj;
		for (var i = 0; i < menuIds.length; i ++) {
			var menu = getForeUIElementById(menuIds[i]);
			$(menu).bind("Expand_Menu", function(event, menuId, index) {
				var menus = obj.find("[id^='" + menuId + "_']");
				var menu = menus.filter("[id^='" + menuId + "_" + (index + 1) + "']");
				var prevVis = menu.css("visibility");
				menus.css("visibility", "hidden");
				if (prevVis != "visible") {
					var subMenu = getForeUIElementById(menuId + "_" + (index + 1))._obj.css("visibility", "inherit");
					var pos = subMenu.position();
					obj.width(pos.left + subMenu.width()).height(Math.max(firstMenuObj.height(), pos.top + subMenu.height()));
				}
			});
		}
		obj.bind("Visible", function() {
			firstMenuObj.css("visibility", "inherit");
			obj.width(firstMenuObj.width()).height(firstMenuObj.height());
		});
	},
	getSelectionIdentification : function() {
		var myId = this._id;
		var menuIds = this._params.menuIds;
		var identification = "";
		for (var i = 0; i < menuIds.length; i ++) {
			var menu = getForeUIElementById(menuIds[i]);
			if (menu._obj.css("visibility") != "hidden") {
				identification = menu._id.slice(myId.length + 1).replace(/_/g, ".");
				if (identification != "") {
					identification = identification.slice(1) + ".";
				}
				identification += menu.getSelectedIndex();
			}
		}
		return identification;
	}
};