var Placeholder = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Placeholder.prototype = {
	init: function() {
		var params = this._params;
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		// create canvas
		var opaque = params.bgo_0 > 0;
		var canvas = createCanvas(width, height, opaque ? undefined : params);
		_fg.empty().append(canvas);
		// draw on canvas
		var ctx = opaque ? canvas.getContext('2d') : getCanvasContext(canvas, params);
		ctx.strokeStyle = params.f_c_0;
		ctx.beginPath();
		var bdw = params.bdw_0;
		var start = { x : bdw, y : bdw };
		var end = { x : width - bdw, y : height - bdw};
		drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, false);
		start = { x : bdw, y : height - bdw };
		end = { x : width - bdw, y : bdw };
		drawSwingLine(ctx, start, end, params.bdsw_int, params.bdsw_amp, false);
		fillAndStrokeOnCanvas(ctx, width, height, params);
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	}
};