var Rectangle = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Rectangle.prototype = {
	init : function() {
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var width = obj.width();
		var height = obj.height();
		
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setBgColor : function(color) {
		var params = this._params;
		params.bg_0 = color;
		updateElementAndReferences(this);
	},
	setBgOpacity : function(opacity) {
		var params = this._params;
		params.bgo_0 = opacity;
		updateElementAndReferences(this);
	}
};