var TextBox = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

TextBox.prototype = {
	init : function() {
		var params = this._params;
		this._text = this._obj.html();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"><table cellspacing=\"0\" cellpadding=\"0\"><tr><td>" + htmlToView(this._text) + "</td></tr></table></div>")
			.appendTo(this._obj);
		
		var margin = params.bd_paint_0 ? params.bdw_0 : 0;
		var align = params["txt_a_" + params.state];
		var valign = params["txt_va_" + params.state];
		this._fg.find("td").css({
				"text-align" : align,
				"vertical-align" : valign,
				"padding" : margin + "px"
			});

		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// text
		var paintBorder = params["bd_paint_" + state];
		var borderWidth = params["bdw_" + state];
		var margin = paintBorder ? borderWidth : 0;
		_fg.find("table").width(width - margin * 2).height(height - margin * 2);
		applyFontParameters(state, "", _fg.find("td").html(htmlToView(this._text)), params);
		
		// shadow
		applyTextShadow(_fg, params);
	},
	getText : function() {
		return textFromView(this._text);
	},
	getCurrentValue : this.getText,
	setCurrentValue : function(text) {
		this._text = text;
		updateElementAndReferences(this);
	},
	setBgColor : function(color) {
		var params = this._params;
		params.bg_0 = params.bg_64 = color;
		updateElementAndReferences(this);
	},
	setBgOpacity : function(opacity) {
		var params = this._params;
		params.bgo_0 = params.bgo_64 = opacity;
		updateElementAndReferences(this);
	},
	setTextColor : function(color) {
		var params = this._params;
		params.f_c_0 = params.f_c_64 = color;
		updateElementAndReferences(this);
	},
	getTextLength : function() {
		return this.getText().length;
	}
};