var VerticalTabs = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

VerticalTabs.prototype = {
	init : function() {
		this._bg = this._obj.children(".bg")
			.css("left", this._params.bd_x + "px");
		this._bd = this._obj.children(".bd")
			.css("left", this._params.bd_x) + "px";
		this._fg = this._obj.children(".fg");
		this.setupBehavior(this._obj);
		initReferences(this);
		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 50);
	},
	updateUI : function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var titleWidth = params.tab_w;
		var titleHeight = params.tab_h;
		var intersect = params.bd_its;
		var width = intersect == "outer" ? obj.width() : (intersect == "inner" ? obj.width() - titleWidth + 1: obj.width() - titleWidth / 2);
		var height = obj.height();
		var swingAmplitude = params["bdsw_amp_" + state];
		
		// background filling
		var viewRc = params.bounds;
		var viewCss = {
			"left" : viewRc.x + "px",
			"top" : viewRc.y + "px",
			"width" : width + "px",
			"height" : height + "px",
			"border-width" : "0px"
		};
		_bg.css(viewCss);
		_bd.css(viewCss);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// tab
		var tabPaddingPx = params.tab_p + "px";
		var tabCount = params.tab_count;
		var selIndex = params.sel_index;
		var titles = params.tabs;
		var icons = params.icons;
		var gap = params.gap;
		var tabHeight = titleHeight + swingAmplitude;
		
		var tabs = _fg.children(".tabs");
		if (params.tab_mode == 1) {
			tabs.css({
				"position" : "absolute",
				"left" : (obj.width() - titleWidth - swingAmplitude) + "px"
			});
		}
		var tabSpans = tabs.children("span");
		tabSpans.each(function(index) {
			var tab = $(this).empty();
			var tabMargin = params[(index == selIndex ? "stab_m_" : "tab_m_") + state];
			
			var label = createLabelObject(icons[index], 0, gap, titles[index]);
			applyFontParameters(state, index == selIndex ? "stab" : "tab", label, params);
			label.css({
				"position" : "absolute",
				"line-height" : titleHeight + "px",
				"display" : "inline-block",
				"padding-left" : tabPaddingPx,
				"padding-right" : tabPaddingPx,
				"vertical-align" : (params.tab_mode == 0 ? "bottom" : "top")
			}).appendTo(tab);
			
			tab.css({
				"position" : "absolute",
				"left" : (params.tab_mode == 1 ? 0 : Math.max(0, tabMargin)) + "px",
				"top" : index * tabHeight + "px",
				"width" : (titleWidth - tabMargin + swingAmplitude) + "px",
				"height" : tabHeight + "px",
				"display" : "block",
				"border-width" : "0px",
				"cursor": (state == 64 || state == 96) ? "default" : "pointer"
			})
			
			var targetId = index == 0 ? "ftab" : (index == tabCount - 1 ? "ltab" : "tab");
			generateBackgroundAndBorders(state, targetId, tab, tab, params);
			if (index == selIndex) {
				var selTabBg = params["stabbg_" + state];
				var selTab = (swingAmplitude == 0 && (selTabBg.indexOf("#") == 0 || selTabBg == "transparent" || selTabBg.indexOf("rgba(") == 0)) ? label : tab;
				changeBackground(state, targetId, selTab, params, selTabBg);
				changeBorders(state, "stab", tab, params);
				if (selTab == label) {
					var bdT = parseInt(tab.css("border-top-width"));
					var bdB = parseInt(tab.css("border-bottom-width"));
					tab.height(tab.height() + bdT + bdB);
					label.width(label.width() + 2);
					label.css(params.tab_mode == 1 ? "right" : "left", "0px");
					applyBorderRadius(state, targetId, label, params);
				}
			}
			label.appendTo(tab);
			
			tab.children("img").css("position", "absolute");
		});
		
		// embedded elements
		obj.children(".fg").children(".views").children().each(function(index) {
			if (index == params.sel_index) {
				$(this).css("visibility", "inherit");
			} else {
				$(this).css("visibility", "hidden");
			}
		});
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		var tabs = obj.children(".fg").children(".tabs").children("span");
		tabs.click(function() {
			if ((me._params.state & 64) == 0) {
				me.setSelectedIndex(tabs.index(this) + 1);
			}
		});
	},
	setSelectedIndex : function(index) {
		if (this._params.sel_index != index - 1) {
			this._params.sel_index = index - 1;
			updateElementAndReferences(this);
			$("#" + this._id).trigger("Selection_Changed");
		}
	},
	getSelectedIndex : function() {
		return this._params.sel_index + 1;
	}
};